//----------------------------------------------------------
function [gmx, gtc] = axscale(x) 
    d10=log10(x)
    z=x*10^-floor(d10)
    if  z <= 1.001 then mx=1; tc=1;
    elseif z <= 2.001 then mx=2; tc=1;
    elseif z <= 5.001 then mx=5; tc=5; 
    else mx=10; tc=5; 
    end
    gmx=mx*10^floor(d10)
    gtc=tc*10^floor(d10)
endfunction
//----------------------------------------------------------
function plotCmplx(mtx,f,text,vh)
    GrayMap=repmat([0:32]'/32,1,3);

    [szx, szy]=size(mtx);
    if argn(2)<4 then
        plx = szx; ply = szy;
    else
        plx = szy; ply = szx;
    end
    mid=round(ply/2);
    clf
    f.color_map=GrayMap;
    f.background=-2;
    f.auto_resize = "off"

    mx=max(abs(mtx));
    [gmx, gtc] = axscale(mx);
    cc=1;

    for iy=1:ply
        subplot(plx+1,ply,cc)
        plot2d(0,0,-1,"035"," ",1.1*[-gmx,0,gmx,gmx/1])
        a=gca();
        a.visible = "off";
        cc=cc+1;
    end

    for ix=1:szx
        for iy=1:szy
            subplot(plx+1,ply,cc);
            plot2d(0,0,-1,"035"," ",1.1*[-gmx,-gmx,gmx,gmx])
            px=real(mtx(ix,iy)); py=imag(mtx(ix,iy));
            xpolys([0 px;px px],[0 py;py py])
            a=gca();
            a.x_label.visible = "off"
            a.y_label.visible = "off"
            a.z_label.visible = "off"
            a.axes_visible = ["off","off","off"]
            m=a.children(1).children(1)
            m.mark_style = 3
            m.mark_background = 25;
            m.mark_size_unit = "point";
            m.mark_size = 6;
            l=a.children(1).children(2);
            l.thickness=3;
            l.foreground = 0;
            xarc(-gmx,gmx,2*gmx,2*gmx,0,360*64)
            xpolys(1.2*[-gmx 0; gmx 0],1.2*[ 0 -gmx; 0 gmx ],[1 1] )
            xstring(-0.0*gmx,0.75*gmx, [sprintf('%5.2f',gmx)]) 
            if cc==mid+ply then
                a.title.text=text;
                a.title.font_size=3;
                a.title.position = [0-gmx*0.2; gmx*1.7]
            end
            cc=cc+1;
        end
    end
endfunction
