// (C) 2014 Yutaka Maeda
clear
//------------S3_2-------------------
//「sin」波を入力し、そのスペクトルを観測。

//　アダマール行列の生成。 
//「8x8」のナチュラル型「アダマール行列」を生成
n=3; N=2^n;  //　< == 文中に誤記が有りました

// Generate Hadamard Natural

//　複製の最小単位「H2」を生成
H2=[1, 1; 1, -1]/2^0.5;
HadNat=H2;

//　「Kron積」により再帰的に複製。 
for i=1:n-1
    HadNat=kron(H2,HadNat);
end

//「ゼロ・クロス」の回数の少ない順で、ソート（「ウォルシュ型」に並べ替え）
ZeroCross=1-HadNat(:,1:N-1).*HadNat(:,2:N);
ix=sum(ZeroCross,2)/2+1;
[s,k]=gsort(ix,'g','i');

//ソート用インデックス「k」を用いて「基底行列B」生成「変換行列A」を生成。、
B=HadNat(k,:);
A=inv(B);  

//基底行列の逆行列（変換行列）が元の基底行列と同じか確認
ErrNorm=norm(A-B) 

// 入力信号の準備 目標信号は１Hzのサイン波です。
t=[0:N-1]/N;
R=sin(2*%pi*t)'; 
figure(100); clf; bar(R) // 目標信号

//スペクトル(基底ベクトルの倍率)を算出
S=A*R;  
figure(110); clf; bar(S)
  
//スペクトルより目標信号を再現(検算)
RR=B*S;
figure(120); clf; bar(RR)
  
//------------S3_3-------------------
//「cos波」を入力し、そのスペクトルを観測。

//目標信号は１Hzのコサイン波です。
R=cos(2*%pi*t)'; 
figure(200); clf; bar(R) // 目標信号

//スペクトル(基底ベクトルの倍率)を算出
S=A*R;  
figure(210); clf; bar(S)
  
//スペクトルより目標信号を再現(検算)
RR=B*S;
figure(220); clf; bar(RR)

//------------S3_4-------------------
// 　「のこぎり波」を入力し、そのスペクトルを観測
//目標信号は１Hzの"のこぎり"波波です。
R=[1:N]';
figure(300); clf; bar(R) // 目標信号
//スペクトル(基底ベクトルの倍率)を算出
S=A*R;  
figure(310); clf; bar(S)
  
//スペクトルより目標信号を再現(検算)
RR=B*S;
figure(320); clf; bar(RR)

