// (C) 2014 Yutaka Maeda
clear

//------------S4_3-------------------
//　「sin」波を入力し、その「スペクトル」を観測

//サイズ「N=8」点の「DCT」 で「、基底行列」<B>、「変換行列」<A>を生成する
n=3; N=2^n;

//--基底行列生成--
for i = 1:N,
    for j = 1:N, 
        if i==1 then c=1/sqrt(2); else c=1;end;
        B(j,i) = sqrt(2/N)*c*cos((i-1)*(j-1/2)*%pi/N); 
    end;
end;
A=B'; //Bの逆行列AはBの転置と等しい

//以下アダマール変換と同一手順。
t=[0:N-1]/N;

//目標信号は１Hzのサイン波です。
R=sin(2*%pi*t)';//Sin波

figure(100); bar(R); 
    
//スペクトル(基底ベクトルの倍率)を算出
S=A*R;
figure(110); bar(S);

//cos波に変えて同一手順で実行。
R=cos(2*%pi*t)'; //Cos波    
figure(200); bar(R);
S=A*R;
figure(210); bar(S);

//こぎり波に変えて同一手順で実行。
R=[1:N]'; //のこぎり波
figure(300); bar(R);
S=A*R;
figure(310); bar(S);
