// (C) 2014 Yutaka Maeda
clear

//------------S5_11------------------

// DFT 変換行列Aを生成
n=8; N=2^n; // N=128

for k = 1:N,
    for l =1:N, 
        A(k,l) = exp(-%i*(k-1)*(l-1)*2*%pi/N);
    end;
end;

// ここでは「振幅変調前」 の「搬送波」として「32Hz」 の「sin波」を考えます。 　
fc=32; // 搬送波 32Hz
fs=8; // 変調波 8Hz
off=1;// 変調波信号オフセットレベル

td=(0:N-1).';
fdix=[N/2+2:N 1:N/2+1]; // 負の周波数表示用X軸インデックス


// 以下は1秒ぶん、つまり「32個の搬送波の波」が存在し、これを「256点」でサンプリングし、プロットしま した。
c=sin(2*%pi*fc*td/N); // 搬送波 32Hz
f=figure(200);clf;
plot2d(td,c);
text='搬送波　fc=32Hz'
title(text);f.axes_size = [800,200];

//　変調信号オフ
as=0; L=('AmpOff')//Amp Off　
sig=as*sin(2*%pi*fs*td/N)+off; // 変調波 8Hzは無信号(=All1)
x=c .* sig; // 無信号で32Hzの搬送波を変調します(要素同士の掛け算)

// DFT変換
y=A*x;

f=figure(210);clf;
bar(td-N/2+1,abs(y(fdix)));
text='振幅スペクトル'
title(text);f.axes_size = [800,200];
a=gca();
a.data_bounds = [-128,0;129,150];
a.auto_ticks = ["on","on","on"];
// 「＋/－」32Hzの部分に搬送波の「スペクトル」が現われています。

// 次に、以下の「8Hz」 の「変調波」 で「32Hz」の搬送波を変調します
as=0.5; L=('AmpOn')//Amp On（変調信号x0.5倍）
sig=as*sin(2*%pi*fs*td/N)+off; // 変調波 8Hz
x=c .* sig; // 変調(要素同士の掛け算)

f=figure(220);clf;
plot2d(td,sig);
text='変調信号波形　fs=8Hz';
title(text); f.axes_size = [800,200];

f=figure(230);clf;
plot2d(td,[x sig -sig]);
text='振幅変調後波形'+L
title(text); f.axes_size = [800,200];
// 搬送波が8Hzの変調波で変調され唸りが生じている様子が分かります。

//DFT変換
y=A*x;

f=figure(240);clf;
bar(td-N/2+1,abs(y(fdix)));
text='振幅スペクトル'+L
title(text);f.axes_size = [800,200];
a=gca();
a.data_bounds = [-128,0;129,150];
a.auto_ticks = ["on","on","on"];
// 搬送波32Hzスペクトルの両脇に変調波 の周波数幅8Hzだけ離れてスペクトルが立ちました

