// (C) 2014 Yutaka Maeda
clear

//------------S5_2-------------------
// 「のこぎり波」を再現

//  C:\MyDirectory に複素表示ライブラリー"MyLib.sci"ある前提
cd C:\MyDirectory
exec('MyLib.sci', -1)

// Setup for 2^n X 2^n DFT Matrix
n=2; N=2^n;

//基底行列を生成。
for k = 1:N,
    for l =1:N, 
        B(k,l) = exp(%i*(k-1)*(l-1)*2*%pi/N)/N;
    end;
end;
clean(B)

//すべて大きさは0.25です。左端、第1列は0Hz（DC）基底です。
//複素平面にプロット。
f=figure(100); clf; plotCmplx(B, f,'B')

//基底行列の逆行列を計算してDFT用の変換行列を生成。
A=inv(B); //基底行列の逆行列が変換行列
clean(A)
//複素平面にプロット。
f=figure(110); clf; plotCmplx(A, f,'A')
//基底行列と逆行列(変換行列)は複素共役か確認
ErrNorm=norm(B.*N-conj(A))

//のこぎり波の信号を設定。
R=[1:N]'; clean(R)
f=figure(120); clf;
plotCmplx(R, f,'R', 1)

//変換行列Aを使ってスペクトルを求めてみましょう。
S=A*R; clean(S)
f=figure(130); clf;
plotCmplx(S, f,'S', 1)

//正しいかどうか、基底行列Bに掛けて検証します。
RR=B*S; clean(RR)
