// (C) 2014 Yutaka Maeda
clear

//------------S6_3（前半）-------------------

//「DFT版」 の「δ」（単位インパルス）の性質を理解するため、
// 少し大きなDFTサイズ： N=100で再実験してみましょう。

N=100;
t=[0:N-1];

//---------------------------------------------------------
// 単位インパルス:「時刻：0」でのみで「パルス」を発生させます
T=100; text='_Delta_T'+sprintf('%i',T);
x=zeros(N,1); x(1:T:N-T+1)=1;
X=fft(x);

f=figure(100); clf; plot2d3(t,x)
a=gca(); p=a.children.children; 
p.thickness = 3
title('TD'+text); f.axes_size = [500,300];

//すべての振幅スペクトルが「1」となりました。その結果、 “真っ黒！” 
fig=110
f=figure(fig); clf;
plot2d3(t,X)
a=gca(); p=a.children.children; 
p.thickness = 3
title('FD'+text); f.axes_size = [500,300];


//---------------------------------------------------------
//パルス間隔T は、全体を「1秒」とする と「25/100=0.25[Sec]」です。
T=25;  text='_Delta_T'+sprintf('%i',T);
x=zeros(N,1); x(1:T:N-T+1)=1;
X=fft(x);
f=figure(200); clf; plot2d3(t,x)
a=gca(); p=a.children.children; 
p.thickness = 3
title('TD'+text); f.axes_size = [500,300];

// 右の図のように、 “縞模様？”になりました。「真っ黒」からは多少薄まっています。 
// 大きさ4の25個のパルス列となりました。
f=figure(210); clf;
plot2d3(t,X)
a=gca(); p=a.children.children; 
p.thickness = 3
title('FD'+text); f.axes_size = [500,300];


//---------------------------------------------------------
// 次は10個のパルスです。 Tは全体を「1秒」とすると「10/100=0.1[Sec]」です
T=10;  text='_Delta_T'+sprintf('%i',T);
x=zeros(N,1); x(1:T:N-T+1)=1;
X=fft(x);
f=figure(300); clf; plot2d3(t,x)
a=gca(); p=a.children.children; 
p.thickness = 3
title('TD'+text); f.axes_size = [500,300];

// 　この場合、結果は「入力」と同じ「10個のパルス」 が「周波数領域」に現われました。  
f=figure(310); clf;
plot2d3(t,X)
a=gca(); p=a.children.children; 
p.thickness = 3
title('FD'+text); f.axes_size = [500,300];
