// (C) 2014 Yutaka Maeda
clear

//------------S6_3(後半)--------------

// 櫛形変調信号
// 三角関数波の搬送波を「櫛型関数」に変えて変調を観察

n=8;
N=2^n;

as=0.5; L=('AmpOn')//Amp On

// DFT 変換行列Aを生成
n=8; N=2^n; // N=128

for k = 1:N,
    for l =1:N, 
        A(k,l) = exp(-%i*(k-1)*(l-1)*2*%pi/N);
    end;
end;

fc=16; // 搬送波 16Hz
fs=4; // 変調波 4Hz
off=1;// 変調波信号オフセットレベル

td=(0:N-1).';
fdix=[N/2+2:N 1:N/2+1]; // 負の周波数表示用X軸インデックス

// 搬送波 16Hzの櫛型関数を生成
c=zeros(N,1); c(1:fc:N-fc+1)=1;

// 変調波（＝サンプリング対称信号）を生成。　４Hzのsin波
as=0.5; 
sig=as*sin(2*%pi*fs*td/N)+off; // 変調波 4Hz+オフセット

// 変調
x=c .* sig;


//DFT変換
y=A*x;


f=figure(100); clf;
plot2d(td,[x sig]);
text='振幅変調後波形+オフセット1'; 
title(text); f.axes_size = [800,200];


f=figure(110); clf;
bar(td-N/2+1,abs(y(fdix)));
text='振幅スペクトル+オフセット1'
title(text); f.axes_size = [800,200];
a=gca();
a.data_bounds = [-128,0;129,30];
a.auto_ticks = ["on","on","on"];


//「変調波」 の「＋1」オフセットを切ってみましょう「。DC成分」 は、なくなるはずです。
off=0;
sig=as*sin(2*%pi*fs*td/N)+off; // 変調波 4Hz＋オフセット無し

// 変調
x=c .* sig;

//DFT変換
y=A*x;

f=figure(200); clf;
plot2d(td,[x sig]);
text='振幅変調後波形 オフセット無し'; 
title(text); f.axes_size = [800,200];


// 予想通り、純粋な「変調波」、つまり「4Hz」 の「sin波」のみになりました
f=figure(220); clf;
bar(td-N/2+1,abs(y(fdix)));
text='振幅スペクトル オフセット無し'
title(text); f.axes_size = [800,200];
a=gca();
a.data_bounds = [-128,0;129,30];
a.auto_ticks = ["on","on","on"];

