clear

//-----実験7_2-----

//-------------S7_2---------------------
//まず、DCTで周波数領域に変換後、フィルタリングした上で、再度IDCTにより時間領域に戻します。
N=4;
//--DCT基底行列生成--
for i = 1:N,
    for j = 1:N, 
        if i==1 then c=1/sqrt(2); else c=1;end;
        B(j,i) = sqrt(2/N)*c*cos((i-1)*(j-1/2)*%pi/N); 
    end;
end;
//--DCT基底行列生成--
A=B.'; //　=Bの転置

//フィルタ無し（λを全て１）の状態での、インパルス入力Rと出力Rfです。
L=[1 1 1 1];
figure(100); bar(L)
L=diag([1 1 1 1])

W=B*L*A;

R=[1 0 0 0].'
figure(110); bar(R)
Rf=W*R;
clean(Rf)
figure(120); bar(Rf)



//入力と同じインパルスが再現されています。

//フィルタに低域通過型寄りの係数を設定してみます。
L=%e^-[0:3]; 
figure(200);  bar(L)
L=diag(L)
W=B*L*A; 
Rf=W*R
figure(210);  bar(Rf)

//指数関数的な応答が得られました。フィルタの効果です。

//この場合の変換行列ｗの確認です。
round(100*W)/100


//複雑な数字が並んでいます。しかしよく見ると縦横対称になっています。
//対称行列あるいはエルミート行列であることが推測されます。

//このデータよりフィルタの係数λを求めて見ましょう。この係数は固有値として求められます。
//scilabでは固有値はspec(W)で計算できます。以下がその結果です。
[eVec eVal ]=spec(W); round(100*eVal)/100

//ちゃんとフィルタの係数が求められました。 
round(100*eVec)/100


round(100*B)/100

//固有ベクトルは第４列の符号が反転しています。
//これは固有ベクトルから成る直行行列が一意的に決まるわけでは無いという事になります。

//直行性を確認してみます。
clean(eVec*eVec')

//対角成分のみ１となり、他は０です。ユニタリー行列（直行行列）であることが確認されました。


//-------------S7_4_1---------------------
//　　　　　 1次方程式

//固有値を再確認。
eVal

//固有ベクトルを再確認。 
eVec
//基底行列Bに相当しています。

//目標信号Rを単位インパルスとしましょう。
//R=W・YとなるYを求めることが今回の目的です。

//この目標信号Rの固有ベクトルに対するスペクトルを求めます。
S=eVec'*R
//変換行列Aを掛けることに相当します。

//スペクトルと固有値の比率を求めます。（固有値の逆特性で補償する）
SL=S./diag(eVal)

//固有値の逆特性で補償されたSLを時間領域にもどします。
Y=eVec*SL

//これが、R=W・Yを満たすYです。解けました。

//YをWで変換してRを再現（検算）します。
Rf=clean(W*Y)
//確かに、Rを再現しています。

//-------------S7_4_2---------------------
//　2次方程式

S=eVec'*R;
L=diag(eVal);

//逆特性による補正の計算は以下の通りです。
SL2=S./(L.^2+L+1);
Y2=eVec*SL2

//以下検算として目標信号Rを再現してみます。
Rf2=W^2*Y2+W*Y2+Y2;
 clean(Rf2)

//正しく入力信号Rが再現されています。
