// (C) 2014 Yutaka Maeda
clear

// 整数周波数の三角関数波を入力。ゼロ詰め無しで（FT_Sim=1）でDFＴを実施。
// 信号入力・表示サイズN2とＤＦＴサイズNは一致。基本周期Tは0.1秒。

FT_Sim=1; //　モニターサイズ比
N2=128; T2=0.1; //モニターウインドサイズ
N=N2*FT_Sim; //全マトリックスサイズ
T=T2*FT_Sim; Ts=T/N; t=Ts*[0:N-1]; w0=2*%pi/T;
n2=[1:N2].'; 
t2=t(n2).';

//--ＤFＴ基底行列生成--
for k = 1:N,
   for l =1:N, 
       B(k,l) = exp(%i*(k-1)*(l-1)*2*%pi/N)/N;
   end;
end;
A=N*conj(B);

// 微分演係数[iω]をフィルタFに設定する。N=8の例：[0Hz 1Hz 2Hz 3Hz 4Hz -3Hz -2Hz -1Hz ]。
// 0Hzより中央まで昇順、以降負の周波数に切り替えて同様に設定。

iw=w0*%i*[[0:N/2] -[N/2-1:-1:1] ];
F=[iw];  

//変換Wを構成する。
W=B*diag(F)*A;   

//2Hzのsin波を生成。
fr=2; x2=sin(fr*2*%pi*t2/T2);    //入力信号設定
x=x2;

//入力信号ｘに対し微分変換Wを実行。
Rf=W*x;

// 出力結果のRfをプロット。比較のために入力信号ｘも表示。
// 三角関数の微積分の公式の通り周波数に応じて振幅が変わります。
// そこでabs(F(fr+1))でRfを割っているのは振幅を表示上、見やすく揃えるための処置です。

f=figure(100); clf; plot (t2,[Rf(n2)/abs(F(fr+1)),x(n2)]);

//フィルタを積分に換えます。iw(1)=1は0Hz時のゼロ割対策です。従って0Hz使用禁止。 
iw(1)=1;

//積分演算子の係数をFに設定し、積分変換Wを生成。
F=[iw].^-1; W=B*diag(F)*A;

//入力信号ｘに対し積分変換Wを実行し表示。
Rf=W*x;
f=figure(200); clf; plot (t2,[Rf(n2)/abs(F(fr+1)),x(n2)]); 
 
//積分変換Wの固有値と固有ベクトルを算出。
[eVec eVal]=spec(W);

//固有値によるフィルタと固有ベクトルを使って行列を再構成し変換を実施。
Rf=eVec*eVal*inv(eVec)*x;
f=figure(300); clf; plot (t2,[Rf(n2)/abs(F(fr+1)),x(n2)]); 
 


