// (C) 2014 Yutaka Maeda
clear

//孤立波を模擬するため、信号部の４倍のサイズでDFTを実施。信号部外の3/4はゼロ詰。

FT_Sim=4; //　モニターサイズ比
N2=128; T2=1; //モニターウインドサイズ
N=N2*FT_Sim; //全マトリックスサイズ
T=T2*FT_Sim; Ts=T/N; t=Ts*[0:N-1]; w0=2*%pi/T;
n2=[1:N2].'; 
t2=t(n2).';

//--ＤFＴ基底行列生成--
for k = 1:N,
    for l =1:N, 
        B(k,l) = exp(%i*(k-1)*(l-1)*2*%pi/N)/N;
    end;
end;
A=N*conj(B);

iw=w0*%i*[[0:N/2] -[N/2-1:-1:1] ];// [0Hz 1Hz 2Hz 3Hz 4Hz ... -3Hz -2Hz -1Hz ] 

//[iω]の代数演算によるフィルタの係数を設定

R=1;L=0.1;C=0.01;
F=[[L*C*iw.^2+R*C*iw+1].^-1 ].'; // 1/{a(iw)^2+b(iw)+c}

//フィルタをＡ、Ｂで挟んで変換Ｗを生成
W=B*diag(F)*A;

//入力信号にN/3の長さのパルスを入力

x2=zeros(N2,1); x2(1:N2/3)=1;    //入力信号設定
x=([x2; zeros(N-N2,1)]);// モニターウインド外にゼロ詰め
Rf=W*x;
figure(100); clf; plot (t2,[Rf(n2),x(n2)]);
 

//変換Ｗの固有値、固有ベクトルを求めます。
[eVec eVal]=spec(W);

//フィルタの代わりに得られた固有値eValを使います。
//この固有値は固有ベクトルと組み合わせれば、(iω)の代数式によるフィルタの係数と同じ役割を果たすはずです。
//基底行列Bの代わりに固有ベクトルeVec、変換行列ＡはeVecの逆行列を使用します。

Rf=eVec*eVal*inv(eVec)*x;

//得られた結果をプロットします。

figure(200); clf; plot (t2,[Rf(n2),x(n2)]);

 
//全く同じ結果が得られました。

