// (C) 2014 Yutaka Maeda
clear

//----- 例題 8-6 -----

//RLCの定数設定、sを多項式として定義
R=1; L=0.1; C=0.01; 
s=poly(0,'s');

//線形システムsyslinに伝達関数“1/(R*C*s+1)”をセット
sys=syslin('c',1/(R*C*s+1)) 

//時間刻みを指定して線形システムシミュレータcsimを実行、入力信号は’impuls’
t=[0:0.0001:0.1];
y=csim('impuls',t,sys);    

//結果ｙをプロット
figure(100); clf; plot(t,y)
 
//＊記載の図は多少見てくれをいじっていますが、同等のものがプロットされるはずです。


//----- 例題 8-7 -----

//極とゼロを表示
figure(200);clf; plzr(sys)
 
//同様に、scilabで伝達関数を“1/(L*C*s^2+R*C*s+1)”として実行。時間tの観測範囲は1秒に拡張。
sys=syslin('c',1/(L*C*s^2+R*C*s+1)) 
t=[0:0.0001:1];
y=csim('impuls',t,sys);    


//結果ｙをプロット
figure(300); clf; plot(t,y)

//極とゼロを表示
figure(400);clf; plzr(sys)

//一度伝達関数を求めておけば、入力を変えるだけで過渡解析が可能となります。
//ユニットステップの入力例です。
N=length(t); Input=zeros(1,N); Input(1:N)=1;
y=csim(Input,t,sys);    

//結果ｙをプロット
figure(500); clf; plot(t,[Input; y])

//1/3[S]長のパルスを入力してみます。
Input=zeros(1,N); Input(1:N/3)=1;
y=csim(Input,t,sys);    

//結果ｙをプロット
figure(600); clf; plot(t,[Input; y])

